0ce44c981a
- Dropped several not-upstreamed patches, some of them neither have history reference nor patch header, some were temporary workaround fix. - device-mapper-gcc-warnings.patch - device-mapper-type_punning.diff - fix-closedown-before-thread-finish.patch - libdm-iface-not-output-error-message-inside-retry-loop.patch - pvcreate-enhance-the-error-message.patch - pvmove_support_clustered_vg.diff - Update to LVM2.2.02.173 - Sync our lvm.conf with V2.02.173 - Dropped several not-upstreamed patches, some of them neither have history reference nor patch header, some were temporary workaround fix. - device-mapper-gcc-warnings.patch - device-mapper-type_punning.diff - fix-closedown-before-thread-finish.patch - libdm-iface-not-output-error-message-inside-retry-loop.patch - pvcreate-enhance-the-error-message.patch - pvmove_support_clustered_vg.diff - Update to LVM2.2.02.173 - Sync our lvm.conf with V2.02.173 - Dropped several not-upstreamed patches, some of them neither have history reference nor patch header, some were temporary workaround fix. - device-mapper-gcc-warnings.patch OBS-URL: https://build.opensuse.org/request/show/514845 OBS-URL: https://build.opensuse.org/package/show/Base:System/lvm2?expand=0&rev=200
159 lines
4.7 KiB
Diff
159 lines
4.7 KiB
Diff
From ecc163a3cb10a8ad89a445ec9d6fdb5a30c380de Mon Sep 17 00:00:00 2001
|
|
From: Eric Ren <zren@suse.com>
|
|
Date: Thu, 6 Jul 2017 17:42:58 +0800
|
|
Subject: [PATCH] fsadm: add support for btrfs
|
|
|
|
Check: mount the device first and then run`btrfs filesystem scrub start
|
|
-B` command
|
|
Reisze: find the mount point first and resize the filesystem after get
|
|
the device id since there are maybe several devices underneath btrfs
|
|
filesystem
|
|
---
|
|
scripts/fsadm.sh | 74 +++++++++++++++++++++++++++++++++++++++++++++++++++++---
|
|
1 file changed, 71 insertions(+), 3 deletions(-)
|
|
|
|
diff --git a/scripts/fsadm.sh b/scripts/fsadm.sh
|
|
index 459905f..1219549 100755
|
|
--- a/scripts/fsadm.sh
|
|
+++ b/scripts/fsadm.sh
|
|
@@ -22,6 +22,7 @@
|
|
# ext2/ext3/ext4: resize2fs, tune2fs
|
|
# reiserfs: resize_reiserfs, reiserfstune
|
|
# xfs: xfs_growfs, xfs_info
|
|
+# btrfs: btrfs
|
|
#
|
|
# Return values:
|
|
# 0 success
|
|
@@ -56,6 +57,7 @@ FSCK=fsck
|
|
XFS_CHECK=xfs_check
|
|
# XFS_REPAIR -n is used when XFS_CHECK is not found
|
|
XFS_REPAIR=xfs_repair
|
|
+BTRFS=btrfs
|
|
|
|
# user may override lvm location by setting LVM_BINARY
|
|
LVM=${LVM_BINARY:-lvm}
|
|
@@ -75,6 +77,9 @@ BLOCKCOUNT=
|
|
MOUNTPOINT=
|
|
MOUNTED=
|
|
REMOUNT=
|
|
+FINDMNT=
|
|
+UUID=
|
|
+BTRFS_DEVID=
|
|
PROCDIR="/proc"
|
|
PROCMOUNTS="$PROCDIR/mounts"
|
|
PROCSELFMOUNTINFO="$PROCDIR/self/mountinfo"
|
|
@@ -225,6 +230,33 @@ detect_fs() {
|
|
verbose "\"$FSTYPE\" filesystem found on \"$VOLUME\"."
|
|
}
|
|
|
|
+check_findmnt() {
|
|
+ FINDMNT=$(which findmnt 2>$NULL)
|
|
+ test -n "$FINDMNT"
|
|
+}
|
|
+
|
|
+detect_fs_uuid() {
|
|
+ UUID=$($BLKID -o value -c $NULL -s UUID "$VOLUME" 2>$NULL)
|
|
+ test -n "$UUID"
|
|
+}
|
|
+
|
|
+#find the mountpoint of this device
|
|
+detect_mounted_findmnt() {
|
|
+ local TMP
|
|
+ local STR_IFS=$IFS
|
|
+ IFS=" $(echo -n -e '\t')"
|
|
+
|
|
+ read -r TMP<<EOF
|
|
+$($FINDMNT -nuP -o TARGET,UUID 2>$NULL | $GREP "$UUID")
|
|
+EOF
|
|
+
|
|
+ TMP=${TMP##*TARGET=\"}
|
|
+ TMP=${TMP%%\"*}
|
|
+ MOUNTED=$TMP
|
|
+ test -n "$MOUNTED"
|
|
+
|
|
+ IFS=$STR_IFS
|
|
+}
|
|
|
|
# Check that passed mounted MAJOR:MINOR is not matching $MAJOR:MINOR of resized $VOLUME
|
|
validate_mounted_major_minor() {
|
|
@@ -352,8 +384,12 @@ detect_mounted_with_proc_mounts() {
|
|
|
|
# check if the given device is already mounted and where
|
|
# FIXME: resolve swap usage and device stacking
|
|
-detect_mounted() {
|
|
- if test -e "$PROCSELFMOUNTINFO"; then
|
|
+detect_mounted() {
|
|
+ if test "$FSTYPE" = "btrfs" ; then
|
|
+ check_findmnt || error "Need 'findmnt' utility to work with btrfs filesystem"
|
|
+ detect_fs_uuid || verbose "Can't get fs UUID from \"$VOLUME\" volume"
|
|
+ detect_mounted_findmnt
|
|
+ elif test -e "$PROCSELFMOUNTINFO"; then
|
|
detect_mounted_with_proc_self_mountinfo
|
|
elif test -e "$PROCMOUNTS"; then
|
|
detect_mounted_with_proc_mounts
|
|
@@ -520,6 +556,31 @@ resize_xfs() {
|
|
fi
|
|
}
|
|
|
|
+########################
|
|
+# Resize btrfs filesystem
|
|
+# - mounted for upsize/downsize
|
|
+# - cannot resize when unmounted
|
|
+########################
|
|
+resize_btrfs() {
|
|
+ detect_mounted
|
|
+ MOUNTPOINT=$MOUNTED
|
|
+ if [ -z "$MOUNTED" ]; then
|
|
+ MOUNTPOINT=$TEMPDIR
|
|
+ temp_mount || error "Cannot mount Btrfs filesystem"
|
|
+ fi
|
|
+
|
|
+ verbose "Parsing $BTRFS filesystem show \"$MOUNTPOINT\""
|
|
+ for i in $(LC_ALL=C "$BTRFS" filesystem show "$MOUNTPOINT"); do
|
|
+ case "$i" in
|
|
+ *"$VOLUME"*) BTRFS_DEVID=${i##*devid};;
|
|
+ esac
|
|
+ done
|
|
+ BTRFS_DEVID=${BTRFS_DEVID%%size*}
|
|
+ BTRFS_DEVID=$(echo $BTRFS_DEVID|sed 's/^[ \t]*//g'|sed 's/[ \t]*$'//g)
|
|
+ decode_size $1 1
|
|
+ verbose "Resizing filesystem on device \"$VOLUME\" to $NEWSIZE bytes(btrfs devid: $BTRFS_DEVID) "
|
|
+ dry "$BTRFS" filesystem resize "$BTRFS_DEVID":"$NEWSIZE" "$MOUNTPOINT"
|
|
+}
|
|
####################
|
|
# Resize filesystem
|
|
####################
|
|
@@ -536,6 +597,7 @@ resize() {
|
|
"ext3"|"ext2"|"ext4") resize_ext $NEWSIZE ;;
|
|
"reiserfs") resize_reiser $NEWSIZE ;;
|
|
"xfs") resize_xfs $NEWSIZE ;;
|
|
+ "btrfs") resize_btrfs $NEWSIZE ;;
|
|
*) error "Filesystem \"$FSTYPE\" on device \"$VOLUME\" is not supported by this tool." ;;
|
|
esac || error "Resize $FSTYPE failed."
|
|
cleanup 0
|
|
@@ -593,6 +655,12 @@ check() {
|
|
# Think about better way....
|
|
dry "$XFS_REPAIR" -n -o force_geometry "$VOLUME"
|
|
fi ;;
|
|
+ "btrfs") #mount the device first and then run scrub
|
|
+ MOUNTPOINT=$TEMPDIR
|
|
+ temp_mount || error "Cannot mount btrfs filesystem"
|
|
+ dry "$BTRFS" scrub start -B "$VOLUME"
|
|
+ test "$MOUNTPOINT" = "$TEMPDIR" && MOUNTPOINT="" temp_umount
|
|
+ ;;
|
|
*) # check if executed from interactive shell environment
|
|
case "$-" in
|
|
*i*) dry "$FSCK" $YES $FORCE "$VOLUME" ;;
|
|
@@ -614,7 +682,7 @@ test -n "$FSADM_RUNNING" && exit 0
|
|
for i in "$TUNE_EXT" "$RESIZE_EXT" "$TUNE_REISER" "$RESIZE_REISER" \
|
|
"$TUNE_XFS" "$RESIZE_XFS" "$MOUNT" "$UMOUNT" "$MKDIR" \
|
|
"$RMDIR" "$BLOCKDEV" "$BLKID" "$GREP" "$READLINK" \
|
|
- "$DATE" "$FSCK" "$XFS_CHECK" "$XFS_REPAIR" "$LVM" ; do
|
|
+ "$DATE" "$FSCK" "$XFS_CHECK" "$XFS_REPAIR" "$LVM" "$BTRFS" ; do
|
|
test -n "$i" || error "Required command definitions in the script are missing!"
|
|
done
|
|
|
|
--
|
|
2.10.2
|
|
|